<?php
if (!defined('_VALID_MOS') && !defined('_JEXEC'))
die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');
if (!class_exists('vmPSPlugin')) require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
require(VMPATH_ROOT .DS.'plugins'.DS.'vmpayment'.DS.'bpc'.DS.'bpc'.DS.'include.php');
if (defined('BPC_ENABLE_CART_OPTIONS') && BPC_ENABLE_CART_OPTIONS === true) {
if (!class_exists('DiscountHelper')) {
require(VMPATH_ROOT . DS . 'plugins' . DS . 'vmpayment' . DS . 'bpc' . DS . 'bpc' . DS . 'DiscountHelper.php');
}
}
class plgVMPaymentBPC extends vmPSPlugin
{
public static $_this = false;
public static $flag = false;
private $redirect_immediately = true;
static protected $vats = array(
'none' => 0,
0 => 1,
10 => 2,
18 => 3,
20 => 6,
);
static protected $measureList = array(
'P' => 0,
'KG' => 11,
'M' => 22,
'SM' => 32,
'L' => 41,
);
public $j_version;
public $allowCallbacks = BPC_ENABLE_CALLBACK;
public $cacert_path = null;
function __construct(& $subject, $config)
{
parent::__construct($subject, $config);
$this->_loggable = true;
$this->tableFields = array_keys($this->getTableSQLFields());
$varsToPush = $this->getVarsToPush();
$this->addVarsToPushCore($varsToPush,1);
$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
$j = new JVersion();
$this->j_version = $j->getLongVersion();
$document = JFactory::getDocument();
if (!defined('BPC_API_VERSION')) {
define('BPC_API_VERSION', 1);
}
$idd_json = json_encode(BPC_API_VERSION);

$jsCode = <<<JS
document.addEventListener('DOMContentLoaded', function() {
let BPC_API_VERSION = JSON.parse('{$idd_json}');
if (BPC_API_VERSION >= 2) {
let l = document.getElementById('params_bpc_merchant').value;
let p = document.getElementById('params_bpc_password').value;
if (l !== '' && p !== '') {
let stringToEncode = l + ':' + p;
let encodedString = btoa(stringToEncode);
console.log(encodedString);
document.getElementById('params_bpc_token').value = encodedString;
}
let el_merchant_bpc = document.getElementById('params_bpc_merchant');
if (el_merchant_bpc) {
el_merchant_bpc.closest('div.control-group').remove();
}
let el_password_bpc = document.getElementById('params_bpc_password');
if (el_password_bpc) {
el_password_bpc.closest('div.control-group').remove();
}
} else {
let el_token_bpc = document.getElementById('params_bpc_token');
if (el_token_bpc) {
el_token_bpc.closest('div.control-group').remove();
}
}
});
JS;
$document->addScriptDeclaration($jsCode);
}
public function plgVmOnUpdateOrderPayment(&$order, $old_order_status) {
if (!($this->_currentMethod = $this->getVmPluginMethod($order->virtuemart_paymentmethod_id))) {
return NULL; // Another method was selected, do nothing
}
if (!$this->selectedThisElement($this->_currentMethod -> payment_element)) {
return NULL;
}
if (!defined('BPC_ENABLE_REFUNDS') || BPC_ENABLE_REFUNDS === false) {
return true;
}

$oModel = VmModel::getModel('orders');
$orderModelData = $oModel->getOrder($order->virtuemart_order_id);
if ($order->order_status == "R" &&  $old_order_status != "R") {
$db = JFactory::getDBO();
$q = 'SELECT * FROM `' . $this->_tablename . '` '
. 'WHERE `virtuemart_order_id` = ' . $order->virtuemart_order_id;
$db->setQuery($q);
if (!($paymentTable = $db->loadObject())) {
vmWarn(500, $q . " " . $db->getErrorMsg());
return false;
}
if (!($method = $this->getVmPluginMethod($order->virtuemart_paymentmethod_id))) {
return null;
}
$args = array(
'orderId' => $paymentTable->bpc_order_id,
'amount' => 0
);
if (defined('BPC_API_VERSION') && BPC_API_VERSION >= 2 && !empty($method->bpc_token)) {
$decoded_credentials = base64_decode($method->bpc_token);
list($l, $p) = explode(':', $decoded_credentials);
$args['userName'] = $l;
$args['password'] = $p;
} else {
$args['userName'] = $method->bpc_merchant;
$args['password'] = $method->bpc_password;
}

if ($method->bpc_test_mode == '1') {
$action_adr = BPC_TEST_URL;
} else {
$action_adr = BPC_PROD_URL;
}
$gose = $this->_sendGatewayData(http_build_query($args, '', '&'), $action_adr . 'getOrderStatusExtended.do');
$res = json_decode($gose, true);
if ($res["orderStatus"] == "2") { //DEPOSITED
$result = $this->_sendGatewayData(http_build_query($args, '', '&'), $action_adr . 'refund.do');
$this->_writeLog("[DEPOSITED REFUND RESPONSE]: ", $args, json_encode($result));
vmWarn(json_decode($result)->errorMessage);
} elseif ($res["orderStatus"] == "1") { //APPROVED 2x
unset($args['amount']);
$result = $this->_sendGatewayData(http_build_query($args, '', '&'), $action_adr . 'reverse.do');
$this->_writeLog("[APPROVED REVERSE RESPONSE]: ", $args, json_encode($result));
vmWarn(json_decode($result)->errorMessage);
} else {
vmError("WRONG GateWay order state [" . $res["orderStatus"] ."]");
return null;
}
$response = json_decode($result, true);
if ($response["errorCode"] != "0") {
if ($response["errorCode"] == "7") {
return false;
}
return false;
} else {
$result = $this->_sendGatewayData(http_build_query($args, '', '&'), $action_adr . 'getOrderStatusExtended.do');
$response = json_decode($result, true);
$orderStatus = $response['orderStatus'];
if ($orderStatus == '4' || $orderStatus == '3') {
return true;
} elseif ($orderStatus == '1') {
return true;
}
}
}
return true;
}
function getTableSQLFields()
{
$SQLfields = array(
'id' => 'int(11) unsigned NOT NULL AUTO_INCREMENT',
'virtuemart_order_number' => 'char(32) DEFAULT NULL',
'virtuemart_order_id' => 'char(32) DEFAULT NULL',
'virtuemart_paymentmethod_id' => 'char(32) DEFAULT NULL',
'payment_name' => 'varchar(5000)',
'rbs_order_id' => 'char(36) DEFAULT NULL'
);
return $SQLfields;
}
function plgVmConfirmedOrder($cart, $order)
{
if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
return null;
}
if (!$this->selectedThisElement($method->payment_element)) {
return false;
}
if (!class_exists('VirtueMartModelOrders')) {
require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
}
$amount = round($order['details']['BT']->order_total * 100);
$jsonParams_array = array(
'CMS' => $this->j_version,
'Module-Version' => "2.3.1"
);
$jsonParams_array['email'] = $order['details']['BT']->email;
$jsonParams_array['phone'] =  preg_replace("/(\W*)/", "", $order['details']['BT']->phone_1);
if (defined('BPC_ENABLE_BACK_URL_SETTINGS')
&& BPC_ENABLE_BACK_URL_SETTINGS === true
&& !empty($method->backToShopUrl)
) {
$jsonParams_array['backToShopUrl'] = $method->backToShopUrl;
}

$args = Array(
'amount' => $amount,
'orderNumber' => $order['details']['BT']->order_number,
'returnUrl' => JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&method=bpc&action=result',
'jsonParams' => json_encode($jsonParams_array),
);

if (defined('BPC_API_VERSION') && BPC_API_VERSION >= 2 && !empty($method->bpc_token)) {
$decoded_credentials = base64_decode($method->bpc_token);
list($l, $p) = explode(':', $decoded_credentials);
$args['userName'] = $l;
$args['password'] = $p;
} else {
$args['userName'] = $method->bpc_merchant;
$args['password'] = $method->bpc_password;
}
$language = substr(JFactory::getLanguage()->getTag(), 0, 2);
switch ($language) {
case  ('uk'):
$language = 'ua';
break;
case ('be'):
$language = 'by';
break;
}
$args['language'] = $language;
if (defined('BPC_MANDATORY_CURRENCY') && BPC_MANDATORY_CURRENCY === true) {
if (!class_exists('VirtueMartModelCurrency')) {
require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
}
$order_currency_id = $order['details']['BT']->order_currency;
$currency_numeric_code = shopFunctions::getCurrencyByID($order_currency_id, 'currency_numeric_code');
$args['currency'] = $currency_numeric_code;
}
if (defined('BPC_SEND_CLIENT_FULL_INFO') && BPC_SEND_CLIENT_FULL_INFO === true) {
$billingPayerData = $this->_getBillingPayerData($order);
if(!empty($billingPayerData)) {
$args['billingPayerData'] = json_encode($billingPayerData);
}
}
if (!empty($order['details']['BT']->virtuemart_user_id && $order['details']['BT']->virtuemart_user_id > 0)) {
$client_email = !empty($order['details']['BT']->email) ? $order['details']['BT']->email : "";
$args['clientId'] = md5($order['details']['BT']->virtuemart_user_id . $client_email . JURI::root());
}
if (defined('BPC_ENABLE_CART_OPTIONS') && BPC_ENABLE_CART_OPTIONS === true && $method->bpc_send_cart_data == 1) {
$orderBundle = array(
'orderCreationDate' => time(),
'customerDetails' => array(
'email' => $order['details']['BT']->email,
'phone' => preg_match('/[7]\d{9}/', $order['details']['BT']->phone_1) ? $order['details']['BT']->phone_1 : ''
),
);
$itemsCnt = 1;
$optionTaxes = array(
'Tax',
'DATax',
'VatTax',
'bDBTax',
'bMarge'
);
if ($cart->products) {
foreach ($cart->products as $key => $product) {
$price = round($cart->cartPrices[$key]['basePriceVariant'] * 100);
$vat = $method->bpc_taxType;
foreach ($optionTaxes as $selectUserTax) {
if (!empty($cart->cartPrices[$key][$selectUserTax])) {
$idTax = array_keys($cart->cartPrices[$key][$selectUserTax]);
$paramsTax = ShopFunctions::getTaxByID($idTax[0]);
$price = round($cart->cartPrices[$key]['salesPrice'] * 100);
if ($paramsTax['calc_value_mathop'] === '+%') {
$taxCalcValue = (int)$paramsTax['calc_value'];
$vat = isset(self::$vats[$taxCalcValue]) ? self::$vats[$taxCalcValue] : $method->bpc_taxType;
} else {
$vat = $method->bpc_taxType;
}
}
}
$item = array();
$item['positionId'] = $itemsCnt++;
$item['name'] = mb_substr($product->product_name, 0, 64);
if ($method->versionFfd == 'v1_05') {
$item['quantity'] = array(
'value' => $product->quantity,
'measure' => (!empty($product->product_unit)) ? $product->product_unit : BPC_MEASUREMENT_NAME
);
}
if ($method->versionFfd == 'v1_2') {
$item['quantity'] = array(
'value' => $product->quantity,
'measure' => BPC_MEASUREMENT_CODE
);
}
$item['itemAmount'] = round($price * $product->quantity);
$item['itemCode'] = $product->virtuemart_product_id;
$item['tax'] = array(
'taxType' => $vat,
'taxSum' => $product->product_tax * 100,
);
$item['itemPrice'] = $price;
$attributes = array();
$attributes[] = array(
"name" => "paymentMethod",
"value" => $method->paymentMethodType
);
$attributes[] = array(
"name" => "paymentObject",
"value" => $method->paymentObjectType
);
$item['itemAttributes']['attributes'] = $attributes;
$orderBundle['cartItems']['items'][] = $item;
}
}
if ($order['details']['BT']->order_shipment > 0) {
$delivery_price = round(($order['details']['BT']->order_shipment + $order['details']['BT']->order_shipment_tax) * 100);
$tax = ShopFunctions::getTaxByID($cart->cartPrices['shipment_calc_id'][0]);
$vat = $method->bpc_taxType;
if (!empty($tax)) {
if ($tax['calc_value_mathop'] === '+%') {
$taxCalcValue = (int)$tax['calc_value'];
$vat = isset(self::$vats[$taxCalcValue]) ? self::$vats[$taxCalcValue] : self::$method->bpc_taxType;
} else {
$vat = $method->bpc_taxType;
}
}
$delivery = array(
'positionId' => $itemsCnt,
'name' => "Delivery",
'itemAmount' => $delivery_price,
'itemCode' => "delivery",
'tax' => array(
'taxType' => $method->bpc_taxType,
'taxSum' => 0,
),
'itemPrice' => $delivery_price,
);

if ($method->versionFfd == 'v1_05') {
$delivery['quantity'] = array(
'value' => 1,
'measure' => BPC_MEASUREMENT_NAME
);
}
if ($method->versionFfd == 'v1_2') {
$delivery['quantity'] = array(
'value' => 1,
'measure' => BPC_MEASUREMENT_CODE
);
}

$attributes = array();
$attributes[] = array(
"name" => "paymentMethod",
"value" => $method->paymentMethodTypeDelivery
);
$attributes[] = array(
"name" => "paymentObject",
"value" => 4
);
$delivery['itemAttributes']['attributes'] = $attributes;
$orderBundle['cartItems']['items'][] = $delivery;
}
if(class_exists('DiscountHelper')) {
$this->discountHelper = new DiscountHelper();
$discount = $this->discountHelper->discoverDiscount($amount, $orderBundle['cartItems']['items']);
if ($discount > 0) {
$this->discountHelper->setOrderDiscount($discount);
$recalculatedPositions = $this->discountHelper->normalizeItems($orderBundle['cartItems']['items']);
$recalculatedAmount = $this->discountHelper->getResultAmount();
$orderBundle['cartItems']['items'] = $recalculatedPositions;
}
}
$args['taxSystem'] = $method->bpc_taxSystem;
$args['orderBundle']['orderCreationDate'] = date('c');
$args['orderBundle'] = json_encode($orderBundle);
} //END send_order
$action_adr = $this->_getGatewayUrl($method);
if ($this->allowCallbacks === true) {
$callback_addresses_string = JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&method=bpc&action=callback';
if (defined('BPC_API_VERSION') && BPC_API_VERSION >= 2 && !empty($method->bpc_token)) {
$decoded_credentials = base64_decode($method->bpc_token);
list($l, $p) = explode(':', $decoded_credentials);
$login = $l;
$password = $p;
} else {
$login = $method->bpc_merchant;
$password = $method->bpc_password;
}

if ($method->bpc_test_mode == '1') {
$gate_url = str_replace("payment/rest", "mportal/mvc/public/merchant/update", $action_adr);
} else {
$gate_url = str_replace("payment/rest", "mportal/mvc/public/merchant/update", $action_adr);
if (defined('BPC_PROD_URL_ALTERNATIVE_DOMAIN')) {
$pattern = '/^https:\/\/[^\/]+/';
$gate_url = preg_replace($pattern, rtrim(BPC_PROD_URL_ALTERNATIVE_DOMAIN, '/'), $gate_url);
}
}
$gate_url .= substr($login, 0, -4); // we guess username = login w/o "-api"
$headers = array(
'Content-Type:application/json',
'Authorization: Basic ' . base64_encode($login . ":" . $password)
);
$data['callbacks_enabled'] = true;
$data['callback_type'] = "STATIC";
$data['callback_addresses'] = $callback_addresses_string;
$data['callback_http_method'] = "GET";
$data['callback_operations'] = "deposited,approved,declinedByTimeout";
$response = $this->_sendGatewayData(json_encode($data), $gate_url, $headers);
$this->_writeLog('ACTION: ' . $gate_url, $data, json_encode($response));
}
if ($method->bpc_two_step == '1') {
$action_adr .= 'registerPreAuth.do';
} else {
$action_adr .= 'register.do';
}
if (file_exists(dirname(__FILE__) . "/bpc/cacert.cer") && $method->enable_cacert == 1) {
$this->cacert_path = dirname(__FILE__) . "/bpc/cacert.cer";
}
$response = $this->_sendGatewayData(http_build_query($args, '', '&'), $action_adr, array('CMS: ' . $args['CMS'], 'Module-Version: ' . "2.3.1"), $this->cacert_path);
$response = json_decode($response, true);
$this->_writeLog("ACTION: " . $action_adr, $args, json_encode($response));
$errorCode = $response['errorCode'];
$html = '';
if ($errorCode == 0) {
$dbValues = array();
$dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
$dbValues['payment_name'] = $this->renderPluginName($method) . '<br />' . $method->payment_info;
$dbValues['virtuemart_order_number'] = $order['details']['BT']->order_number;
$dbValues['virtuemart_order_id'] = $order['details']['BT']->virtuemart_order_id;
$dbValues['rbs_order_id'] = $response['orderId'];
$this->storePSPluginInternalData($dbValues);
if (!empty($response['formUrl']) && $this->redirect_immediately == true) {
header("Location: " . $response['formUrl']);
exit;
} else {
$html .= 'Please wait, we are redirecting you to the payment screen... <br>';
$html .= '<a class="button cancel" href="' . $response['formUrl'] . '">Click here</a> if you do not get redirected.';
}
} else {
$html .= "ERRORCODE #" . $errorCode . ": " . $response['errorMessage'];
}
return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $method->payment_name);
}
function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id)
{
if (!$this->selectedThisByMethodId($virtuemart_payment_id)) {
return null;
}
$db = JFactory::getDBO();
$q = 'SELECT * FROM `' . $this->_tablename . '` '
. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
$db->setQuery($q);
if (!($paymentTable = $db->loadObject())) {
vmWarn(500, $q . " " . $db->getErrorMsg());
return '';
}
$this->getPaymentCurrency($paymentTable);
$html = '<table class="adminlist table">';
$html .= $this->getHtmlHeaderBE();
$html .= $this->getHtmlRowBE('%MODULE_NAME%', $paymentTable->payment_name);
$html .= '</table>';
return $html;
}
function plgVmOnPaymentResponseReceived(&$html)
{

$input = JFactory::getApplication()->input;
if ($input->get('method', '', 'cmd') != 'bpc') {
return NULL;
}
if (self::$flag) return null;
$jlang = JFactory::getLanguage();
$jlang->load('plg_vmpayment_bpc', JPATH_ADMINISTRATOR);
$payment_data = vRequest::getGet();
if (isset($payment_data['method']) && $payment_data['method'] == "bpc") {
vmdebug('plgVmOnPaymentResponseReceived', $payment_data);
if (!class_exists('VirtueMartModelOrders')) {
require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
}
$args = array();
$action = $payment_data['action'];
switch ($action) {
case "result":
$args['orderId'] = isset($payment_data['orderId']) ? $payment_data['orderId'] : null;
break;
case "callback":
$args['orderId'] = isset($payment_data['mdOrder']) ? $payment_data['mdOrder'] : null;
break;
}
$rbs_order_id = $args['orderId'];
$q = 'SELECT `virtuemart_order_id` FROM `' . $this->_tablename . '` WHERE `rbs_order_id`="' . $rbs_order_id . '"';
$db = JFactory::getDBO();
$db->setQuery($q);
$virtuemart_order_id = $db->loadResult();
$q = 'SELECT `virtuemart_paymentmethod_id` FROM `' . $this->_tablename . '` WHERE `rbs_order_id`="' . $rbs_order_id . '"';
$db = JFactory::getDBO();
$db->setQuery($q);
$virtuemart_paymentmethod_id = $db->loadResult();
$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
if (defined('BPC_API_VERSION') && BPC_API_VERSION >= 2 && !empty($method->bpc_token)) {
$decoded_credentials = base64_decode($method->bpc_token);
list($l, $p) = explode(':', $decoded_credentials);
$args['userName'] = $l;
$args['password'] = $p;
} else {
$args['userName'] = $method->bpc_merchant;
$args['password'] = $method->bpc_password;
}
$action_adr = $this->_getGatewayUrl($method);
$action_adr .= 'getOrderStatusExtended.do';
$response = $this->_sendGatewayData(http_build_query($args, '', '&'), $action_adr);
$this->_writeLog("ACTION: " . $action_adr, $args, json_encode($response));
$response = json_decode($response, true);
$modelOrder = VmModel::getModel('orders');
$orderStatus = $response['orderStatus'];
switch ($action) {
case "result":
if ($orderStatus == '1' || $orderStatus == '2') {
$order = array();
$current_order = $modelOrder->getOrder($virtuemart_order_id);
$html .= vmText::_('VMPAYMENT_BPC_ENTRY_ORDER') . " " . $current_order['details']['BT']->order_number . ", " . vmText::_('VMPAYMENT_BPC_ENTRY_WAS_PAID') . ".";
if ($this->allowCallbacks === false) {
$order['order_status'] = "C";
$order['comments'] = 'BPC [' . $rbs_order_id . ']';
if ($current_order['details']['BT']->order_status == "P") {
$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
}
}
if (!class_exists('VirtueMartCart')) {
require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
}
$cart = VirtueMartCart::getCart();
if (!class_exists('VirtueMartModelOrders')) {
require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
}
$cart->emptyCart();
self::$flag = true;
return true;
} else {
if ($this->allowCallbacks === false) {
$order = array();
$order['order_status'] = "X";
$order['comments'] = 'BPC ' . $rbs_order_id;
$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
}
$html .= vmText::_('VMPAYMENT_BPC_ENTRY_PAYMENT_ERROR') . ' <a href="' . JURI::root() . 'index.php?option=com_virtuemart&view=cart"> ' . vmText::_('VMPAYMENT_BPC_ENTRY_TRY_AGAIN') . '</a>.';
}
return null;
break;
case "callback":
if ($orderStatus == '1' || $orderStatus == '2') {
$order = array();
$current_order = $modelOrder->getOrder($virtuemart_order_id);
$order['order_status'] = "C";
$order['comments'] = 'BPC [' . $rbs_order_id . ']';
if ($current_order['details']['BT']->order_status == "P") {
$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
}
return true;
} else {
$order = array();
$order['order_status'] = "X";
$order['comments'] = 'BPC ' . $rbs_order_id;
$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
}
break;
}
}
}
function plgVmOnUserPaymentCancel()
{
return null;
}
function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
{

return $this->onStoreInstallPluginTable($jplugin_id);
}
/**
* This event is fired after the payment method has been selected. It can be used to store
* additional payment info in the cart.
**
* @param VirtueMartCart $cart: the actual cart
* @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
*
*/
public function plgVmOnSelectCheckPayment (VirtueMartCart $cart, &$msg) {
return $this->OnSelectCheck ($cart);
}
/**
* plgVmDisplayListFEPayment
* This event is fired to display the plugin methods in the cart (edit shipment/payment) for example
*
* @param object  $cart Cart object
* @param integer $selected ID of the method selected
* @return boolean True on success, false on failures, null when this plugin was not selected.
* On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
*
*/
public function plgVmDisplayListFEPayment (VirtueMartCart $cart, $selected, &$htmlIn) {
return $this->displayListFE ($cart, $selected, $htmlIn);
}

public function plgVmOnSelectedCalculatePricePayment (VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
return $this->onSelectedCalculatePrice ($cart, $cart_prices, $cart_prices_name);
}
function plgVmgetPaymentCurrency ($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
if (!($method = $this->getVmPluginMethod ($virtuemart_paymentmethod_id))) {
return NULL; // Another method was selected, do nothing
}
if (!$this->selectedThisElement ($method->payment_element)) {
return FALSE;
}
$this->getPaymentCurrency ($method);
$paymentCurrencyId = $method->payment_currency;
return;
}
function plgVmOnCheckAutomaticSelectedPayment (VirtueMartCart $cart, array $cart_prices, &$paymentCounter) {
return $this->onCheckAutomaticSelected ($cart, $cart_prices, $paymentCounter);
}
public function plgVmOnShowOrderFEPayment ($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
$this->onShowOrderFE ($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
}
function plgVmOnShowOrderPrintPayment ($order_number, $method_id) {
return $this->onShowOrderPrint ($order_number, $method_id);
}
function plgVmDeclarePluginParamsPaymentVM3( &$data) {
return $this->declarePluginParams('payment', $data);
}
function plgVmSetOnTablePluginParamsPayment ($name, $id, &$table) {
return $this->setOnTablePluginParams ($name, $id, $table);
}
function plgVmDeclarePluginParamsPayment($name, $id, &$data)
{
return $this->declarePluginParams('payment', $name, $id, $data);
}

protected function getVmPluginCreateTableSQL()
{
return $this->createTableSQL('Payment %MODULE_NAME% Table');
}
protected function checkConditions($cart, $method, $cart_prices)
{
return true;
}
public function _sendGatewayData($data, $action_address, $headers = array(), $ca_info = null)
{
$curl_opt = array(
CURLOPT_HTTPHEADER => $headers,
CURLOPT_VERBOSE => true,
CURLOPT_SSL_VERIFYHOST => false,
CURLOPT_URL => $action_address,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => $data,
CURLOPT_HEADER => true,
);
$ssl_verify_peer = false;
if ($ca_info != null) {
$ssl_verify_peer = true;
$curl_opt[CURLOPT_CAINFO] = $ca_info;
}
$curl_opt[CURLOPT_SSL_VERIFYPEER] = $ssl_verify_peer;
$ch = curl_init();
curl_setopt_array($ch, $curl_opt);
$response = curl_exec($ch);
if ($response === false) {
$response['errorCode'] = 999;
$response['errorMessage'] = curl_error($ch);
return json_encode($response);
}
$header_size = curl_getinfo($ch, CURLINFO_HEADER_SIZE);
curl_close($ch);
return substr($response, $header_size);
}
function _getGatewayUrl($method) {
if ($method->bpc_test_mode == '1') {
$action_adr = BPC_TEST_URL;
} else {
$action_adr = BPC_PROD_URL;
if (defined('BPC_PROD_URL_ALTERNATIVE_DOMAIN') && defined('BPC_PROD_URL_ALT_PREFIX')) {
if (substr($method->bpc_merchant, 0, strlen(BPC_PROD_URL_ALT_PREFIX)) == RBPC_PROD_URL_ALT_PREFIX) {
$pattern = '/^https:\/\/[^\/]+/';
$action_adr = preg_replace($pattern, rtrim(BPC_PROD_URL_ALTERNATIVE_DOMAIN, '/'), $action_adr);
} else {
$this->allowCallbacks = false;
}
}
}
return $action_adr;
}
function _writeLog($info, $request, $response)
{
if (defined('BPC_ENABLE_LOGGING') && BPC_ENABLE_LOGGING !== true) {
return false;
}
if (isset($request['password'])) {
$request['password'] = "***removed from log***";
}
$date = JFactory::getDate();
$path = JPATH_ADMINISTRATOR . "/logs/vm_bpc_" . date('Y-m') . ".log";
error_log($date->Format('Y-m-d H:i:s') . " " . $info . "\nREQUEST: " . json_encode($request) . "\nRESPONSE: " . $response . "\n\n", 3, $path);
}
function logingActions($params)
{
jimport('joomla.error.log');
$options = array('format' => "{DATE}\t{TIME}\t{ORDER}\t{ACTION}");
$log = &JLog::getInstance('payment_events.log.php', $options);
$log->addEntry(array('ORDER' => $params['ORDER'], 'ACTION' => $params['ACTION']));
}
function _getBillingPayerData($order) {
$billingPayerData = array();
$billingAddress = $order['details']['BT'];
if (!empty($billingAddress->city)) {
$billingPayerData['billingCity'] = $billingAddress->city;
}
if (!empty($billingAddress->virtuemart_country_id)) {
$countryModel = VmModel::getModel('Country');
$country = $countryModel->getCountry($billingAddress->virtuemart_country_id);
if (!empty($country->country_2_code)) {
$billingPayerData['billingCountry'] = $country->country_2_code;
}
}
if (!empty($billingAddress->address_1)) {
$billingPayerData['billingAddressLine1'] = $billingAddress->address_1;
}
if (!empty($billingAddress->address_2)) {
$billingPayerData['billingAddressLine2'] = $billingAddress->address_2;
}
if (!empty($billingAddress->zip)) {
$billingPayerData['billingPostalCode'] = $billingAddress->zip;
}
if (!empty($billingAddress->virtuemart_state_id)) {
$stateModel = VmModel::getModel('State');
$state = $stateModel->getSingleState($billingAddress->virtuemart_state_id);
if (!empty($state->state_name)) {
$billingPayerData['billingState'] = $state->state_name;
}
}
return $billingPayerData;
}

}